/* This program demonstrates the populating of tables in a ProDataSet with a 
   single invocation of the READ-XML method of the PDS.                      */

/* Definition for Temp-Table ttCust */
DEFINE TEMP-TABLE ttCust    NO-UNDO LIKE Customer  BEFORE-TABLE bttCust.
DEFINE TEMP-TABLE ttOrd     NO-UNDO LIKE Order     BEFORE-TABLE bttOrd.
DEFINE TEMP-TABLE ttOrdLine NO-UNDO LIKE OrderLine BEFORE-TABLE bttOrdLine.

/* Definition of the ProDataSet */
DEFINE DATASET myds 
  NAMESPACE-URI "urn:myds"
  FOR ttCust, ttOrd, ttOrdLine
      DATA-RELATION custOrd FOR ttCust, ttOrd 
         RELATION-FIELDS(CustNum, CustNum) NESTED
      DATA-RELATION ordOline FOR ttOrd, ttOrdLine
         RELATION-FIELDS(OrderNum, OrderNum) NESTED.



/* Single invocation populates the temp-tables */
DATASET myds:READ-XML ("FILE", "custOrd.xml","EMPTY",?,?).


/* Display the data in the temp-tables */
PAUSE 0 BEFORE-HIDE.
CURRENT-WINDOW:WIDTH = 100.
DISPLAY "XML DEMO" AT 31 WITH FRAME BKGROUND WIDTH 72 DOWN NO-BOX STREAM-IO.
forblk:
FOR EACH ttcust:
  DISPLAY "Customer Info:" SKIP
           ttcust.CustNum AT 10 ttcust.Name ttcust.Country  SKIP (2)
          "   Order Info:"
    WITH STREAM-IO CENTERED OVERLAY NO-BOX ROW 3 NO-LABELS. 
  FOR EACH ttOrd OF ttCust:
    DISPLAY ttOrd.CustNum ttOrd.Ordernum ttOrd.OrderDate shipdate Carrier 
        WITH STREAM-IO CENTERED OVERLAY 1 COLUMN NO-BOX ROW 8.
    PAUSE BEFORE-HIDE.
    FOR EACH ttOrdLine OF ttOrd:
       DISPLAY LineNum QTY ItemNum ExtendedPrice (TOTAL) 
          WITH STREAM-IO CENTERED OVERLAY NO-BOX.
    END.    /* For each ttOrdLine */
  END.   /* For each ttOrd */
END.  /* For each ttcust */

