/* This program demonstrates the generation of an xml file from the temp-tables
   in a ProDataSet.  Run this program twice.  1st as writen, then using the
   NESTED relationship option.                                               */
DEFINE VAR hds                    AS HANDLE     NO-UNDO.
DEFINE VAR lwriteStatus           AS LOGICAL    NO-UNDO.

/* Definition for Temp-Table ttCust */
DEFINE TEMP-TABLE ttCust    NO-UNDO LIKE Customer  BEFORE-TABLE bttCust.
DEFINE TEMP-TABLE ttOrd     NO-UNDO LIKE Order     BEFORE-TABLE bttOrd.
DEFINE TEMP-TABLE ttOrdLine NO-UNDO LIKE OrderLine BEFORE-TABLE bttOrdLine.

/* Definition of the ProDataSet */
DEFINE DATASET myds 
  NAMESPACE-URI "urn:myds"
  FOR ttCust, ttOrd, ttOrdLine
    DATA-RELATION custOrd FOR ttCust, ttOrd 
       RELATION-FIELDS (CustNum, CustNum) /*NESTED*/
    DATA-RELATION ordOline FOR ttOrd, ttOrdLine
       RELATION-FIELDS (OrderNum, OrderNum) /*NESTED*/.

/* Define the DataSources of the temp-table in the ProDataSet */
DEFINE DATA-SOURCE dsCust FOR customer.
DEFINE DATA-SOURCE dsOrd FOR order.
DEFINE DATA-SOURCE dsOrdLine FOR orderline.

/* Attach the data-sources to the dataset buffers */
BUFFER ttCust:HANDLE:ATTACH-DATA-SOURCE(DATA-SOURCE dsCust:HANDLE,?,?,?).
BUFFER ttOrd:HANDLE:ATTACH-DATA-SOURCE(DATA-SOURCE dsOrd:HANDLE,?,?,?).
BUFFER ttOrdLine:HANDLE:ATTACH-DATA-SOURCE(DATA-SOURCE dsOrdLine:HANDLE,?,?,?).

/* Being able to set the FILL-WHERE-STRING is new 10.1A feature */
DATA-SOURCE dsCust:FILL-WHERE-STRING = "where customer.country = 'Finland'".

/* Populate the dataset */
DATASET myds:FILL().



/* Single invocation of the WRITE-XML method of the PDS generates the entire
   XML file.                                                              */
lwriteStatus = DATASET myds:WRITE-XML (
                 "FILE",         /* Destination type                      */
                 "custord.xml",  /* Destination name                      */
                 YES,            /* Format with whitespace                */
                 ?,              /* Encoding                              */
                 ?,              /* SchemaLocation                        */
                 NO,             /* Write the schema                      */
                 ?,              /* Minimum schema                        */
                 NO).            /* Don't write out the Before table data */



IF lwriteStatus EQ TRUE THEN
  MESSAGE "ProDataSet written to XML file (custord.xml)"
    VIEW-AS ALERT-BOX.
